option symbolgen spool;
%let currpath="C:\Documents and Settings\vacogrierm\Desktop\distributions2010";
%let datafile="C:\Documents and Settings\vacogrierm\Desktop\distributions2010\LifeExpectancy.csv";
libname pus &currpath;
libname frmlib &currpath;
%let thk = 2;

PROC IMPORT OUT= pus.poltable 
            DATAFILE= &datafile 
            DBMS=CSV REPLACE;
     GETNAMES=YES;
     DATAROW=2; 
RUN;

data lt.LifeTable(keep=age nol mle);
  set work.LifeTable;
  label age = 'Exact Age'
		nol = 'Male Number of Living'
		mle = 'Male Life Expectancy'
        ;
  if age = . then delete;
run;

proc sql;
  create table lt.goldengates2 as
  select a.DeathAge, a.Time, a.ClockYear, a.Personid, b.age as eage, b.mle 
    from lt.goldengates a full join lt.lifetable b
    on a.DeathAge = b.mle
    where DeathAge ne .
    order by personid;
quit;

%macro getnol;
%global RC;
%let RC=;
%let inreturned=;
proc sql noprint;
  select nol into :inret 
    from lt.LifeTable where age = &a ;
  select 1-nol/&inret into :p
    from lt.LifeTable where age = &b ;
quit;
%mend getnol;

proc fcmp outlib = sasuser.ds.functions;
   function getnol_macro(a, b);
      rc = run_macro('getnol', a, b, p);
      if rc eq 0 then return(p);
      else return(.);
   endsub;
run;
option nosymbolgen;
option cmplib = (sasuser.ds);
data lt.test;
  set lt.LifeTable;
  PD1=getnol_macro(age,age+1);
  PD2=getnol_macro(age,age+2);
  PD3=getnol_macro(age,age+3);
  PD4=getnol_macro(age,age+4);
  PD5=getnol_macro(age,age+5);
  PD6=getnol_macro(age,age+6);
  PD7=getnol_macro(age,age+7);
  PD8=getnol_macro(age,age+8);
  PD9=getnol_macro(age,age+9);
  PD10=getnol_macro(age,age+10);
  PD11=getnol_macro(age,age+11);
  PD12=getnol_macro(age,age+12);
  PD13=getnol_macro(age,age+13);
  PD14=getnol_macro(age,age+14);
  PD15=getnol_macro(age,age+15);
  PD16=getnol_macro(age,age+16);
  PD17=getnol_macro(age,age+17);
  PD18=getnol_macro(age,age+18);
  PD19=getnol_macro(age,age+19);
  PD20=getnol_macro(age,age+20);
  PD21=getnol_macro(age,age+21);
  PD22=getnol_macro(age,age+22);
  PD23=getnol_macro(age,age+23);
  PD24=getnol_macro(age,age+24);
  PD25=getnol_macro(age,age+25);
  PD26=getnol_macro(age,age+26);
  PD27=getnol_macro(age,age+27);
  PD28=getnol_macro(age,age+28);
  PD29=getnol_macro(age,age+29);
  PD30=getnol_macro(age,age+30);
  PD31=getnol_macro(age,age+31);
  PD32=getnol_macro(age,age+32);
  PD33=getnol_macro(age,age+33);
  PD34=getnol_macro(age,age+34);
  PD35=getnol_macro(age,age+35);
  PD36=getnol_macro(age,age+36);
  PD37=getnol_macro(age,age+37);
  PD38=getnol_macro(age,age+38);
  PD39=getnol_macro(age,age+39);
  PD40=getnol_macro(age,age+40);
  PD41=getnol_macro(age,age+41);
  PD42=getnol_macro(age,age+42);
  PD43=getnol_macro(age,age+43);
  PD44=getnol_macro(age,age+44);
  PD45=getnol_macro(age,age+45);
  PD46=getnol_macro(age,age+46);
  PD47=getnol_macro(age,age+47);
  PD48=getnol_macro(age,age+48);
  PD49=getnol_macro(age,age+49);
  PD50=getnol_macro(age,age+50);
  PD51=getnol_macro(age,age+51);
  PD52=getnol_macro(age,age+52);
  PD53=getnol_macro(age,age+53);
  PD54=getnol_macro(age,age+54);
  PD55=getnol_macro(age,age+55);
  PD56=getnol_macro(age,age+56);
  PD57=getnol_macro(age,age+57);
  PD58=getnol_macro(age,age+58);
  PD59=getnol_macro(age,age+59);
  PD60=getnol_macro(age,age+60);
  PD61=getnol_macro(age,age+61);
  PD62=getnol_macro(age,age+62);
  PD63=getnol_macro(age,age+63);
  PD64=getnol_macro(age,age+64);
  PD65=getnol_macro(age,age+65);
  PD66=getnol_macro(age,age+66);
  PD67=getnol_macro(age,age+67);
  PD68=getnol_macro(age,age+68);
  PD69=getnol_macro(age,age+69);
  PD70=getnol_macro(age,age+70);
  PD71=getnol_macro(age,age+71);
  PD72=getnol_macro(age,age+72);
  PD73=getnol_macro(age,age+73);
  PD74=getnol_macro(age,age+74);
  PD75=getnol_macro(age,age+75);
  PD76=getnol_macro(age,age+76);
  PD77=getnol_macro(age,age+77);
  PD78=getnol_macro(age,age+78);
  PD79=getnol_macro(age,age+79);
  PD80=getnol_macro(age,age+80);
  PD81=getnol_macro(age,age+81);
  PD82=getnol_macro(age,age+82);
  PD83=getnol_macro(age,age+83);
  PD84=getnol_macro(age,age+84);
  PD85=getnol_macro(age,age+85);
  PD86=getnol_macro(age,age+86);
  PD87=getnol_macro(age,age+87);
  PD88=getnol_macro(age,age+88);
  PD89=getnol_macro(age,age+89);
  PD90=getnol_macro(age,age+90);
  PD91=getnol_macro(age,age+91);
  PD92=getnol_macro(age,age+92);
  PD93=getnol_macro(age,age+93);
  PD94=getnol_macro(age,age+94);
  PD95=getnol_macro(age,age+95);
  PD96=getnol_macro(age,age+96);
  PD97=getnol_macro(age,age+97);
  PD98=getnol_macro(age,age+98);
  PD99=getnol_macro(age,age+99);
  PD100=getnol_macro(age,age+100);

run;

/*
data lt.alive2020;
  set lt.goldengates2;
  inc=2020-ClockYear;
  pd=getnol_macro(eage,eage+inc);
 *  if Time < 2021 then delete;
  if ClockYear> 2020 then delete;
run;
proc sql;
  create table lt.alive2020cnts as 
  select eage, inc, count(*) as alcnt
    from lt.alive2020
	where eage > 17
    group by eage, inc;
quit;

data lt.alive2020cnts;
  set lt.alive2020cnts;
  age2020=eage+inc;
  pd=getnol_macro(eage,age2020);
  alcnt2=round(alcnt*(1-pd),1);
run;
proc sql;
  create table lt.alive2020cnts2 as
  select age2020, sum(alcnt2) as alcnt
  from lt.alive2020cnts
    group by age2020;
quit;
proc sql;
  select sum(alcnt) into :al2 from lt.alive2020cnts2;
quit;
data lt.alive2020cnts2;
  set lt.alive2020cnts2;
  prob=round(alcnt/&al2,0.000001);
run;

goptions reset=all;
ods html gpath=&graphpath;
proc sgplot data=lt.alive2020cnts2;
  title "Veteran age distribution 2020, by Conditional Probability";
  xaxis min=17 max=105;
  series x=age2020 y=prob / lineattrs=(thickness=&thk) ;
run;
*/
%macro pltyear(fyr=);
data lt.alive&fyr;
  set lt.goldengates2;
  inc=&fyr-ClockYear;
  pd=getnol_macro(eage,eage+inc);
 *  if Time < 2030 then delete;
  if ClockYear> &fyr then delete;
run;

proc sql;
  create table lt.alive&fyr.cnts as 
  select eage, inc, count(*) as alcnt
    from lt.alive&fyr
	where eage > 17
    group by eage, inc;
quit;

data lt.alive&fyr.cnts;
  set lt.alive&fyr.cnts;
  age&fyr=eage+inc;
  pd=getnol_macro(eage,age&fyr);
  alcnt2=round(alcnt*(1-pd),1);
run;
proc sql;
  create table lt.alive&fyr.cnts2 as
  select age&fyr, sum(alcnt2) as alcnt
  from lt.alive&fyr.cnts
    group by age&fyr;
quit;
proc sql;
  select sum(alcnt) into :al2 from lt.alive&fyr.cnts2;
quit;
data lt.alive&fyr.cnts2;
  set lt.alive&fyr.cnts2;
  prob=round(alcnt/&al2,0.000001);
run;

goptions reset=all;
ods html gpath=&graphpath;
proc sgplot data=lt.alive&fyr.cnts2;
  title "Veteran age distribution &fyr, by Conditional Probability";
  xaxis min=17 max=105;
  series x=age&fyr y=prob / lineattrs=(thickness=&thk) ;
run;
%mend pltyear;

%pltyear(fyr=2020);
%pltyear(fyr=2030);
%pltyear(fyr=2040);
%pltyear(fyr=2050);
%pltyear(fyr=2060);
%pltyear(fyr=2070);
